#! /bin/bash

PACKAGE_NAME="printer-driver-bisheng-zdesigner-105sl-203dpi"
PACKAGE_VERSION="2.0.1"
PRINTER_NAME=( "ZDesigner 105SL 203DPI" "ZDesigner 105SL 300DPI" "ZDesigner 105SLPlus-203dpi ZPL" "ZDesigner 105SLPlus-300dpi ZPL" "ZDesigner 110PAX4 203DPI" "ZDesigner 110PAX4 300DPI" "ZDesigner 110Xi4 203 dpi" "ZDesigner 110Xi4 300 dpi" "ZDesigner 110Xi4 600 dpi" "ZDesigner 110XiIII Plus 200DPI" "ZDesigner 110XiIII Plus 300DPI" "ZDesigner 110XiIII Plus 600DPI" "ZDesigner 140Xi4 203 dpi" "ZDesigner 140XiIII Plus" "ZDesigner 170PAX4 203DPI" "ZDesigner 170PAX4 300DPI" "ZDesigner 170Xi4 203 dpi" "ZDesigner 170Xi4 300 dpi" "ZDesigner 170XiIII Plus" "ZDesigner 170XiIII Plus 200DPI" "ZDesigner 220Xi4 203 dpi" "ZDesigner 220Xi4 300 dpi" "ZDesigner 220XiIII Plus" "ZDesigner 220XiIII Plus 300DPI" "ZDesigner 888-DT" "ZDesigner 888-TT" "ZDesigner EZ 320" "ZDesigner GC420d" "ZDesigner GC420d -EPL-" "ZDesigner GC420t" "ZDesigner GC420t -EPL-" "ZDesigner GK420d" "ZDesigner GK420d -EPL-" "ZDesigner GK420t" "ZDesigner GK420t -EPL-" "ZDesigner GK888d" "ZDesigner GK888d -EPL-" "ZDesigner GK888t" "ZDesigner GK888t -EPL-" "ZDesigner GT800 -EPL-" "ZDesigner GT800 -ZPL-" "ZDesigner GT800-300dpi EPL" "ZDesigner GT800-300dpi ZPL" "ZDesigner GX420d" "ZDesigner GX420d -EPL-" "ZDesigner GX420s" "ZDesigner GX420s -EPL-" "ZDesigner GX420t" "ZDesigner GX420t -EPL-" "ZDesigner GX430t" "ZDesigner GX430t -EPL-" "ZDesigner HC100 300 dpi" "ZDesigner iMZ220" "ZDesigner iMZ220 -ZPL-" "ZDesigner iMZ320" "ZDesigner iMZ320 -ZPL-" "ZDesigner KR403" "ZDesigner LP 2824" "ZDesigner LP 2824 Plus -EPL-" "ZDesigner LP 2824 Plus -ZPL-" "ZDesigner LP 2844" "ZDesigner LP 2844-Z" "ZDesigner Mobile Printer" "ZDesigner MZ 220" "ZDesigner MZ 320" "ZDesigner P4T -CPCL-" "ZDesigner P4T -ZPL-" "ZDesigner QL 220-QL 220 Plus" "ZDesigner QL 320-QL 320 Plus" "ZDesigner QL 420-QL 420 Plus" "ZDesigner QLn220" "ZDesigner QLn220 -ZPL-" "ZDesigner QLn320" "ZDesigner QLn320 -ZPL-" "ZDesigner QLn420 -CPCL-" "ZDesigner QLn420 -ZPL-" "ZDesigner R110PAX4 LH-203DPI" "ZDesigner R110PAX4 LH-300DPI" "ZDesigner R110PAX4 RH-203DPI" "ZDesigner R110PAX4 RH-300DPI" "ZDesigner R110Xi 200DPI" "ZDesigner R110Xi 300DPI" "ZDesigner R110Xi HF 200DPI" "ZDesigner R110Xi HF 300DPI" "ZDesigner R110Xi4 203 dpi" "ZDesigner R110Xi4 300 dpi" "ZDesigner R110Xi4 600 dpi" "ZDesigner R170Xi 200DPI" "ZDesigner R170Xi 300DPI" "ZDesigner R2844-Z" "ZDesigner RP4T -ZPL-" "ZDesigner RW 220" "ZDesigner RW 420" "ZDesigner RW4-PS" "ZDesigner RZ400 200 dpi" "ZDesigner RZ400 300 dpi" "ZDesigner RZ600 200 dpi" "ZDesigner RZ600 300 dpi" "ZDesigner S4M-203dpi EPL" "ZDesigner S4M-203dpi ZPL" "ZDesigner S4M-300dpi ZPL" "ZDesigner TLP 2824" "ZDesigner TLP 2824 Plus -EPL-" "ZDesigner TLP 2824 Plus -ZPL-" "ZDesigner TLP 2844" "ZDesigner TLP 2844-Z" "ZDesigner TLP 3842" "ZDesigner TLP 3844-Z" "ZDesigner ZD500R-203dpi ZPL" "ZDesigner ZD500R-300dpi ZPL" "ZDesigner ZE500-4 LH-203dpi ZPL" "ZDesigner ZE500-4 LH-300dpi ZPL" "ZDesigner ZE500-4 RH-203dpi ZPL" "ZDesigner ZE500-4 RH-300dpi ZPL" "ZDesigner ZE500R-4 LH-203dpi ZPL" "ZDesigner ZE500R-4 LH-300dpi ZPL" "ZDesigner ZE500R-4 RH-203dpi ZPL" "ZDesigner ZE500R-4 RH-300dpi ZPL" "ZDesigner ZE500-6 LH-203dpi ZPL" "ZDesigner ZE500-6 LH-300dpi ZPL" "ZDesigner ZE500-6 RH-203dpi ZPL" "ZDesigner ZE500-6 RH-300dpi ZPL" "ZDesigner ZE511 LH-203dpi ZPL" "ZDesigner ZE511 LH-300dpi ZPL" "ZDesigner ZE511 LH-600dpi ZPL" "ZDesigner ZE511 RH-203dpi ZPL" "ZDesigner ZE511 RH-300dpi ZPL" "ZDesigner ZE511 RH-600dpi ZPL" "ZDesigner ZE511R LH-203dpi ZPL" "ZDesigner ZE511R LH-300dpi ZPL" "ZDesigner ZE511R LH-600dpi ZPL" "ZDesigner ZE511R RH-203dpi ZPL" "ZDesigner ZE511R RH-300dpi ZPL" "ZDesigner ZE511R RH-600dpi ZPL" "ZDesigner ZE521 LH-203dpi ZPL" "ZDesigner ZE521 LH-300dpi ZPL" "ZDesigner ZE521 RH-203dpi ZPL" "ZDesigner ZE521 RH-300dpi ZPL" "ZDesigner ZE521R LH-203dpi ZPL" "ZDesigner ZE521R LH-300dpi ZPL" "ZDesigner ZE521R RH-203dpi ZPL" "ZDesigner ZE521R RH-300dpi ZPL" "ZDesigner ZM400 200 dpi -EPL-" "ZDesigner ZM400 200 dpi -ZPL-" "ZDesigner ZM400 300 dpi -ZPL-" "ZDesigner ZM400 600 dpi -ZPL-" "ZDesigner ZM600 200 dpi -EPL-" "ZDesigner ZM600 200 dpi -ZPL-" "ZDesigner ZM600 300 dpi -ZPL-" "ZDesigner ZQ310 -ZPL-" "ZDesigner ZQ310 -CPCL-" "ZDesigner ZQ320 -ZPL-" "ZDesigner ZQ320 -CPCL-" "ZDesigner ZQ510 -ZPL-" "ZDesigner ZQ510 -CPCL-" "ZDesigner ZQ520 -ZPL-" "ZDesigner ZQ520 -CPCL-" "ZDesigner ZT210-200dpi EPL" "ZDesigner ZT210-200dpi ZPL" "ZDesigner ZT210-300dpi ZPL" "ZDesigner ZT220-200dpi EPL" "ZDesigner ZT220-200dpi ZPL" "ZDesigner ZT220-300dpi ZPL" "ZDesigner ZT230-200dpi EPL" "ZDesigner ZT230-200dpi ZPL" "ZDesigner ZT230-300dpi ZPL" "ZDesigner ZT410-203dpi EPL" "ZDesigner ZT410-203dpi ZPL" "ZDesigner ZT410-300dpi ZPL" "ZDesigner ZT410-600dpi ZPL" "ZDesigner ZT420-203dpi ZPL" "ZDesigner ZT420-300dpi ZPL" "ZDesigner ZT410R-203dpi ZPL" "ZDesigner ZT410R-300dpi ZPL" "ZDesigner ZT410R-600dpi ZPL" "ZDesigner ZT420R-203dpi ZPL" "ZDesigner ZT420R-300dpi ZPL" "ZDesigner ZT510-203dpi ZPL" "ZDesigner ZT510-300dpi ZPL" "ZDesigner ZT610-203dpi ZPL" "ZDesigner ZT610-300dpi ZPL" "ZDesigner ZT610-600dpi ZPL" "ZDesigner ZT620-203dpi ZPL" "ZDesigner ZT620-300dpi ZPL" "ZDesigner ZT610R-203dpi ZPL" "ZDesigner ZT610R-300dpi ZPL" "ZDesigner ZT610R-600dpi ZPL" "ZDesigner ZT620R-203dpi ZPL" "ZDesigner ZT620R-300dpi ZPL" "ZDesigner ZD500-203dpi ZPL" "ZDesigner ZD500-300dpi ZPL" "ZDesigner ZD500-203dpi EPL" "ZDesigner ZD500-300dpi EPL" "ZDesigner ZD410-203dpi ZPL" "ZDesigner ZD410-300dpi ZPL" "ZDesigner ZD410-203dpi EPL" "ZDesigner ZD410-300dpi EPL" "ZDesigner ZD411-203dpi ZPL" "ZDesigner ZD411-300dpi ZPL" "ZDesigner ZD411-203dpi EPL" "ZDesigner ZD411-300dpi EPL" "ZDesigner ZD420-203dpi ZPL" "ZDesigner ZD420-300dpi ZPL" "ZDesigner ZD420-203dpi EPL" "ZDesigner ZD420-300dpi EPL" "ZDesigner ZD421-203dpi ZPL" "ZDesigner ZD421-300dpi ZPL" "ZDesigner ZD421-203dpi EPL" "ZDesigner ZD421-300dpi EPL" "ZDesigner ZD421CN-300dpi ZPL" "ZDesigner ZD421CN-300dpi EPL" "ZDesigner ZD611-203dpi ZPL" "ZDesigner ZD611R-203dpi ZPL" "ZDesigner ZD611-300dpi ZPL" "ZDesigner ZD611R-300dpi ZPL" "ZDesigner ZD611-203dpi EPL" "ZDesigner ZD611-300dpi EPL" "ZDesigner ZD621-203dpi ZPL" "ZDesigner ZD621R-203dpi ZPL" "ZDesigner ZD621-300dpi ZPL" "ZDesigner ZD621R-300dpi ZPL" "ZDesigner ZD621-203dpi EPL" "ZDesigner ZD621-300dpi EPL" "ZDesigner ZR318 -ZPL-" "ZDesigner ZR318 -CPCL-" "ZDesigner ZR328 -ZPL-" "ZDesigner ZR328 -CPCL-" "ZDesigner ZR338 -CPCL-" "ZDesigner ZR338 -ZPL-" "ZDesigner ZR628 -CPCL-" "ZDesigner ZR628 -ZPL-" "ZDesigner ZR638 -CPCL-" "ZDesigner ZR638 -ZPL-" "ZDesigner ZD620-203dpi ZPL" "ZDesigner ZD620-300dpi ZPL" "ZDesigner ZD620-203dpi EPL" "ZDesigner ZD620-300dpi EPL" "ZDesigner GK420E -ZPL-" "ZDesigner GK420E -EPL-" "ZDesigner GK888E -ZPL-" "ZDesigner GK888E -EPL-" "ZDesigner ZQ610 -CPCL-" "ZDesigner ZQ610 -ZPL-" "ZDesigner ZQ620 -CPCL-" "ZDesigner ZQ620 -ZPL-" "ZDesigner ZR658 -CPCL-" "ZDesigner ZR658 -ZPL-" "ZDesigner ZR668 -CPCL-" "ZDesigner ZR668 -ZPL-" "ZDesigner GK420t Plus -ZPL-" "ZDesigner GK420t Plus -EPL-" "ZDesigner ZD510-300dpi ZPL" "ZDesigner GT800 Plus -EPL-" "ZDesigner GT800 Plus -ZPL-" "ZDesigner ZD511-300dpi ZPL" "ZDesigner ZQ630 -CPCL-" "ZDesigner ZQ630 -ZPL-" "ZDesigner ZQ630R -ZPL-" "ZDesigner ZQ120 -CPCL-" "ZDesigner ZQ220 -CPCL-" "ZDesigner ZR138 -CPCL-" "ZDesigner ZD220-203dpi ZPL" "ZDesigner ZD220-203dpi EPL" "ZDesigner ZD230-203dpi ZPL" "ZDesigner ZD230-203dpi EPL" "ZDesigner ZD888-203dpi ZPL" "ZDesigner ZD888-203dpi EPL" "ZDesigner ZT411-203dpi EPL" "ZDesigner ZT411-203dpi ZPL" "ZDesigner ZT411-300dpi ZPL" "ZDesigner ZT411-600dpi ZPL" "ZDesigner ZT421-203dpi ZPL" "ZDesigner ZT421-300dpi ZPL" "ZDesigner ZT411R-203dpi ZPL" "ZDesigner ZT411R-300dpi ZPL" "ZDesigner ZT411R-600dpi ZPL" "ZDesigner ZT421R-203dpi ZPL" "ZDesigner ZT421R-300dpi ZPL" "ZDesigner ZQ511 -ZPL-" "ZDesigner ZQ511 -CPCL-" "ZDesigner ZQ521 -ZPL-" "ZDesigner ZQ521 -CPCL-" "ZDesigner ZQ511R -ZPL-" "ZDesigner ZQ521R -ZPL-" "ZDesigner ZQ112 -CPCL-" "ZDesigner ZQ210 -CPCL-" "ZDesigner ZR118 -CPCL-" "ZDesigner ZT111-203dpi EPL" "ZDesigner ZT111-203dpi ZPL" "ZDesigner ZT111-300dpi ZPL" "ZDesigner ZT211-203dpi EPL" "ZDesigner ZT211-203dpi ZPL" "ZDesigner ZT211-300dpi ZPL" "ZDesigner ZT231-203dpi EPL" "ZDesigner ZT231-203dpi ZPL" "ZDesigner ZT231-300dpi ZPL" "ZDesigner ZT231R-203dpi ZPL" "ZDesigner ZT231R-300dpi ZPL" )

CONTAINER_PATH="$HOME/.deepinwine/$PACKAGE_NAME"
OPT_PATH="/opt/deepinwine/printer_drv/$PACKAGE_NAME"
WINEBIN="bisheng"
REGDIR="reg"
FILEDIR="files"

PRINTER_C=$1
found=0
for name in "${PRINTER_NAME[@]}"; do
    if [ "$PRINTER_C" = "$name" ]; then
        found=1
        break
    fi
done

if [ $found -eq 0 ]; then
    echo "printer $PRINTER_C not found"
    exit 0
fi

if [ -z "$PACKAGE_NAME" -o ! -d "$OPT_PATH" ]; then
    exit 1
fi

if [ -d "$CONTAINER_PATH" ]; then
    # compare version
    if [ ! -f "$CONTAINER_PATH/VERSION" ] || [ "$(cat "$CONTAINER_PATH/VERSION")" != "$PACKAGE_VERSION" ]; then
        rm -rf "$CONTAINER_PATH"
    fi
fi

WININI="$CONTAINER_PATH/drive_c/windows/win.ini"
if [ -f  $WININI ]; then
    grep -q "^$PRINTER_C=winerp.drv,USB" "$WININI" && exit 0
fi

if [ -d "$OPT_PATH/$REGDIR" ]; then
    find "$OPT_PATH/$REGDIR" -type f -regex ".*\.reg" | while read file; do
        WINEPREFIX=$CONTAINER_PATH $WINEBIN regedit "$file"
    done
fi

if [ -d "$OPT_PATH/$FILEDIR" ]; then
    find "$OPT_PATH/$FILEDIR" -not -type d | while read file; do
        path="$CONTAINER_PATH/drive_c/${file#*$FILEDIR/}"
        dir="${path%/*}"
        mkdir -p "$dir"
        cp -d "$file" "$path"
    done
fi

if [ -f "$WININI" ]; then
    grep -q "^\[devices\]" "$WININI" || sed -i -e "$ a [devices]" "$WININI"
    grep -q "^\[PrinterPorts\]" "$WININI" || sed -i -e "$ a [PrinterPorts]" "$WININI"
    sed -i -e "/^\[devices\]/a $PRINTER_C=winerp.drv,USB" "$WININI"
    sed -i -e "/^\[PrinterPorts\]/a $PRINTER_C=winerp.drv,USB,15,45" "$WININI"
fi

WINESERVER_RUNNING=1
WINESERVER_FINDNUM=0
while [ $WINESERVER_RUNNING -eq 1 ]
do
        WINESERVER_PATH=`ps -aux|grep wineserver|grep -v grep`
        if [ "$WINESERVER_PATH" = "" ] || [ $WINESERVER_FINDNUM -eq 3 ]; then
                WINESERVER_RUNNING=0
        else
                let WINESERVER_FINDNUM+=1
                sleep 1
        fi
done

echo "$PACKAGE_VERSION" > "$CONTAINER_PATH/VERSION"
echo "$PRINTER_NAME" > "$CONTAINER_PATH/name.log"
